rtld: limit self loading check to normal mode only

Commit glibc-2.14~10 disallowed rtld self loading to avoid a segfault
that used to happen when rtld was loading itself in normal mode.
Unfortunately, that commit disallowed all modes of self loading,
including those that used to work before.  This change limits the check
for self loading to normal mode only, so that instruments like ldd could
handle rtld properly.
This commit is contained in:
Dmitry V. Levin 2012-08-22 00:43:21 +00:00
parent ae30640a32
commit f3fd569c36
5 changed files with 62 additions and 4 deletions

View File

@ -1,3 +1,11 @@
2012-09-19 Dmitry V. Levin <ldv@altlinux.org>
[BZ #14579]
* elf/rtld.c (dl_main): Limit the check for self loading to normal
mode only.
* elf/tst-rtld-load-self.sh: New test.
* elf/Makefile: Run it.
2012-09-18 Joseph Myers <joseph@codesourcery.com>
* sysdeps/wordsize-64/Makefile [$(subdir) = misc]

4
NEWS
View File

@ -13,8 +13,8 @@ Version 2.17
13542, 13717, 13696, 13939, 13966, 14042, 14090, 14166, 14150, 14151,
14154, 14157, 14166, 14173, 14195, 14237, 14252, 14283, 14298, 14303,
14307, 14328, 14331, 14336, 14337, 14347, 14349, 14459, 14476, 14505,
14510, 14516, 14518, 14519, 14532, 14538, 14544, 14545, 14576, 14583,
14587
14510, 14516, 14518, 14519, 14532, 14538, 14544, 14545, 14576, 14579,
14583, 14587.
* Support for STT_GNU_IFUNC symbols added for s390 and s390x.
Optimized versions of memcpy, memset, and memcmp added for System z10 and

View File

@ -434,7 +434,7 @@ generated += $(addsuffix .so,$(strip $(modules-names)))
ifeq (yes,$(build-shared))
ifeq ($(cross-compiling),no)
tests: $(objpfx)tst-pathopt.out
tests: $(objpfx)tst-pathopt.out $(objpfx)tst-rtld-load-self.out
endif
endif
@ -707,6 +707,9 @@ $(objpfx)tst-pathopt.out: tst-pathopt.sh $(objpfx)tst-pathopt \
$(objpfx)pathoptobj.so
$(SHELL) -e $< $(common-objpfx)
$(objpfx)tst-rtld-load-self.out: tst-rtld-load-self.sh $(objpfx)ld.so
$(SHELL) $^ > $@
$(objpfx)initfirst: $(libdl)
$(objpfx)initfirst.out: $(objpfx)firstobj.so

View File

@ -1093,7 +1093,8 @@ of this helper program; chances are you did not intend to run this program.\n\
/* Now the map for the main executable is available. */
main_map = GL(dl_ns)[LM_ID_BASE]._ns_loaded;
if (GL(dl_rtld_map).l_info[DT_SONAME] != NULL
if (__builtin_expect (mode, normal) == normal
&& GL(dl_rtld_map).l_info[DT_SONAME] != NULL
&& main_map->l_info[DT_SONAME] != NULL
&& strcmp ((const char *) D_PTR (&GL(dl_rtld_map), l_info[DT_STRTAB])
+ GL(dl_rtld_map).l_info[DT_SONAME]->d_un.d_val,

46
elf/tst-rtld-load-self.sh Executable file
View File

@ -0,0 +1,46 @@
#! /bin/sh
# Test how rtld loads itself.
# Copyright (C) 2012 Free Software Foundation, Inc.
# This file is part of the GNU C Library.
#
# The GNU C Library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.
# The GNU C Library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
# Lesser General Public License for more details.
# You should have received a copy of the GNU Lesser General Public
# License along with the GNU C Library; if not, see
# <http://www.gnu.org/licenses/>.
set -e
rtld=$1
result=0
echo '# normal mode'
$rtld $rtld 2>&1 && rc=0 || rc=$?
echo "# exit status $rc"
test $rc -le 127 || result=1
echo '# list mode'
$rtld --list $rtld 2>&1 && rc=0 || rc=$?
echo "# exit status $rc"
test $rc -eq 0 || result=1
echo '# verify mode'
$rtld --verify $rtld 2>&1 && rc=0 || rc=$?
echo "# exit status $rc"
test $rc -eq 2 || result=1
echo '# trace mode'
LD_TRACE_LOADED_OBJECTS=1 $rtld $rtld 2>&1 && rc=0 || rc=$?
echo "# exit status $rc"
test $rc -eq 0 || result=1
exit $result